(window.webpackJsonp=window.webpackJsonp||[]).push([[168],{"./version-control/diff/constants.ts":function(e,t,r){"use strict";r.r(t),r.d(t,"ENABLE_DIFF_MERGE_V2_FLAG",(function(){return o})),r.d(t,"DiffVersion",(function(){return s}));const o={key:"enable-diff-merge-v2",defaultValue:!1},s={V1:"v1",V2:"v2"}},"./version-control/pull-request/components/MergeConditions.js":function(e,t,r){"use strict";r.r(t),r.d(t,"EmptyState",(function(){return j})),r.d(t,"default",(function(){return I}));var o=r("../../node_modules/react/index.js"),s=r.n(o),n=r("./node_modules/lodash/lodash.js"),i=r.n(n),l=r("../../node_modules/@postman/aether/esmLib/index.js"),a=r("../../node_modules/@postman/aether-icons/esmLib/index.js"),c=r("../../node_modules/styled-components/dist/styled-components.browser.esm.js"),u=(r("./version-control/pull-request/services/PullRequestService.js"),r("./appsdk/contextbar/ContextBarViewHeader.js")),d=(r("./js/components/base/LoadingIndicator.js"),r("./js/components/base/Text.js"),r("./js/components/base/Buttons.js")),m=r("./appsdk/components/link/Link.js"),p=r("./js/stores/SyncStatusStore.js"),g=r("./js/stores/StoreManager.js"),f=r("./version-control/common/index.js"),h=r("./version-control/pull-request/hooks/usePullRequestMergeSettingsViewPermission.js");const v="You can perform this action once you're back online",y=c.default.span`
  font-size: var(--text-size-m);
  font-weight: var(--text-weight-medium);
  color: var(--content-color-brand);
  cursor: ${e=>e.disabled?"not-allowed":"pointer"};
  opacity: ${e=>e.disabled&&"0.5"};
  pointer-events: ${e=>e.disabled&&"not-allowed"};
`,q=c.default.div`
  margin: var(--spacing-l) 0;
`,b=c.default.div`
  height: 56px;
  width: 56px;
  background-color: var(--background-color-tertiary);
  border-radius: var(--border-radius-max);
  display: flex;
  align-items: center;
  justify-content: space-around;

  & svg, & i {
    height: ${({theme:e})=>e["size-m"]};
    width: ${({theme:e})=>e["size-m"]};
  }
`,E=c.default.div`
  margin-top: ${({theme:e})=>e["spacing-l"]};
  maring-bottom: ${({theme:e})=>e["spacing-l"]};
`,P=c.default.div`
  margin-top: ${({theme:e})=>e["spacing-xs"]};
  margin-bottom: ${({theme:e})=>e["spacing-l"]};
  text-align: center;
`;function j(e){return s.a.createElement("div",{className:"pull-request-container__empty-state"},e.icon&&s.a.createElement(b,{className:"sidebar-empty-state__icon-container"},s.a.createElement(a.Icon,{className:"sidebar-empty-state__icon",size:"large",color:"content-color-tertiary",name:e.icon})),e.illustration&&e.illustration,s.a.createElement(E,null,s.a.createElement(l.Heading,{text:e.title,type:"h4",hasBottomSpacing:!0})),s.a.createElement(P,null,s.a.createElement(l.Text,{type:"body-medium",text:e.message,color:"content-color-secondary"})),e.showAction&&s.a.createElement(d.Button,{type:"primary",onClick:()=>e.actionHandler&&e.actionHandler(),size:"small",disabled:e.isOffline||e.disableNavigation,tooltip:e.primaryActionTooltip||e.isOffline&&v,tooltipPlacement:"bottom"},e.navigationParams?s.a.createElement(m.default,e.navigationParams,e.actionTitle):e.actionTitle),e.showSecondaryAction&&s.a.createElement(q,null,s.a.createElement(f.CustomTooltip,{align:"bottom",body:e.isOffline&&v},s.a.createElement(y,{onClick:()=>e.secondaryActionHandler&&e.secondaryActionHandler(),disabled:e.isOffline},e.secondaryActionTitle))))}function I(e){const t=e.contextData.mergeChecks||[],r=e.contextData.errorLoadingMergeChecks,n=!Object(g.resolveStoreInstance)(p.default).isSocketConnected,c=i.a.get(e,"contextData.pullRequest.destination.id"),d=i.a.get(e,"contextData.pullRequest.entity"),{permission:m,error:f}=Object(h.default)(d,c);return s.a.createElement(o.Fragment,null,s.a.createElement(u.ContextBarViewHeader,{title:e.title,onClose:e.onClose}),s.a.createElement("section",{className:"pull-request-meta__section pull-request-merge-check__section"},r&&s.a.createElement(j,{showAction:!0,actionHandler:()=>e.contextData.errorActionHandler(i.a.get(e.contextData,"pullRequest.id")),actionTitle:"Retry",illustration:s.a.createElement(l.IllustrationInternalServerError,null),title:"Unable to load merge settings",message:r&&r.message||"We were unable to fetch merge settings. Please try again later.",isOffline:n}),!r&&!t.length&&s.a.createElement(j,{showAction:!0,illustration:s.a.createElement(l.IllustrationMergeConditions,null),actionTitle:"Open Merge Settings",title:"Set merge conditions for this collection",message:"Maintain version control with clear, simple rules for when a pull request can be merged.",navigationParams:m&&!n&&{to:{routeIdentifier:"build.roles.manage",queryParams:{collection:i.a.get(e.contextData,"pullRequest.toId")}}},disableNavigation:!m,primaryActionTooltip:n?v:"boolean"==typeof m&&!m||f?"You cannot view merge settings for this pull request.":void 0,id:i.a.get(e.contextData,"pullRequest.toId"),isOffline:n}),!r&&!!t.length&&s.a.createElement(o.Fragment,null,s.a.createElement("span",{className:"pull-request__merge-checks-header"},"This pull request:"),s.a.createElement("ul",{className:"pull-request-settings-list"},t.map((e=>s.a.createElement("div",{className:"pull-request-merge-check",key:e.id},e.satisfied?s.a.createElement(a.Icon,{name:"icon-state-success-stroke",color:"base-color-success",size:"large"}):s.a.createElement(a.Icon,{name:"icon-state-error-stroke",color:"base-color-warning",size:"large"}),s.a.createElement("span",{className:"pull-request-merge-check__description"},e.description))))))))}},"./version-control/pull-request/config/collection.ts":function(e,t,r){"use strict";r.r(t);t.default={displayName:"collection",permissions:{viewMergeSettings:({modelId:e,userId:t})=>({entityType:"user",entityId:t,permission:"VIEW_PULL_REQUEST_SETTINGS",objectType:"collection",objectId:e}),viewModel:"VIEW_COLLECTION",editModel:"UPDATE_COLLECTION"}}},"./version-control/pull-request/config/environment.ts":function(e,t,r){"use strict";r.r(t);t.default={displayName:"environment",permissions:{viewMergeSettings:({modelId:e,userId:t})=>({entityType:"user",entityId:t,permission:"VIEW_PULL_REQUEST_SETTINGS",objectType:"environment",objectId:e}),viewModel:"VIEW_ENVIRONMENT",editModel:"UPDATE_ENVIRONMENT"}}},"./version-control/pull-request/config/index.ts":function(e,t,r){"use strict";r.r(t);var o=r("./version-control/pull-request/config/collection.ts"),s=r("./version-control/pull-request/config/environment.ts");const n={collection:o.default,environment:s.default};t.default=n},"./version-control/pull-request/hooks/usePullRequestMergeSettingsViewPermission.js":function(e,t,r){"use strict";r.r(t),r.d(t,"default",(function(){return l}));var o=r("../../node_modules/react/index.js"),s=r("./version-control/pull-request/services/PullRequestService.js"),n=r("./js/stores/CurrentUserStore.js"),i=r("./js/stores/StoreManager.js");function l(e,t){const[r,l]=Object(o.useState)(!1),[a,c]=Object(o.useState)(),[u,d]=Object(o.useState)(),m=Object(o.useRef)(),p=Object(i.resolveStoreInstance)(n.default).id;return Object(o.useEffect)((()=>(m.current=!0,(async()=>{try{m.current&&l(!0);const r=await Object(s.checkPullRequestMergeSettingViewPermission)({model:e,modelId:t,userId:p});m.current&&c(r)}catch(e){m.current&&d(e.error||e)}finally{m.current&&l(!1)}})(),()=>{m.current=!1})),[]),{isLoading:r,permission:a,error:u}}},"./version-control/pull-request/services/PullRequestService.js":function(e,t,r){"use strict";r.r(t),r.d(t,"fetchPullRequest",(function(){return p})),r.d(t,"fetchPullRequests",(function(){return g})),r.d(t,"fetchPullRequestSettings",(function(){return f})),r.d(t,"fetchPullRequestDiff",(function(){return h})),r.d(t,"fetchDiff",(function(){return v})),r.d(t,"fetchMergeStrategies",(function(){return y})),r.d(t,"createPullRequest",(function(){return q})),r.d(t,"updatePullRequest",(function(){return b})),r.d(t,"mergePullRequest",(function(){return E})),r.d(t,"declinePullRequest",(function(){return P})),r.d(t,"approvePullRequest",(function(){return j})),r.d(t,"unapprovePullRequest",(function(){return I})),r.d(t,"fetchCollectionRoles",(function(){return w})),r.d(t,"fetchModelPermissions",(function(){return _})),r.d(t,"isPublicCollection",(function(){return S})),r.d(t,"fetchSuggestedReviewers",(function(){return R})),r.d(t,"updateEntityPullRequestSettings",(function(){return x})),r.d(t,"fetchEntityPullRequestSettings",(function(){return T})),r.d(t,"checkPullRequestMergeSettingViewPermission",(function(){return L})),r.d(t,"getPullRequestCommentingPermissions",(function(){return k}));var o=r("./node_modules/lodash/lodash.js"),s=r.n(o),n=r("./node_modules/querystring-browser/querystring.js"),i=r.n(n),l=r("./js/modules/services/RemoteSyncRequestService.js"),a=r("./js/stores/CurrentUserStore.js"),c=r("./js/stores/StoreManager.js"),u=r("./version-control/pull-request/config/index.ts"),d=r("./onboarding/src/common/LaunchDarkly.js"),m=r("./version-control/diff/constants.ts");function p(e,t){const r=t?{populateUsers:t}:{};let o=s.a.isEmpty(r)?`/v1/pull-requests/${e}`:`/v1/pull-requests/${e}?${i.a.stringify(r)}`;return l.default.request("/ws/proxy",{method:"post",data:{service:"vcs",method:"get",path:o}}).then((({body:e})=>Promise.resolve(e))).catch((({error:e})=>Promise.reject({message:"Something went wrong while fetching the pull request."})))}function g(e,t){const r={entity:e,toId:t,populateUsers:!0};return l.default.request("/ws/proxy",{method:"post",data:{service:"vcs",method:"get",path:`/v1/pull-requests?${i.a.stringify(r)}`}}).then((({body:e})=>Promise.resolve(e))).catch((({error:e})=>Promise.reject(e)))}function f(e){const t={entity:"collection",entityId:e,mergers:!0,populateUsers:!0};if(e)return l.default.request("/ws/proxy",{method:"post",data:{service:"vcs",method:"get",path:`/v1/pull-request-settings?${i.a.stringify(t)}`}}).then((({body:e})=>Promise.resolve(e))).catch((({error:e})=>Promise.reject(e)));pm.logger.error("PullRequestService~fetchPullRequestSettings: No object id specified to fetch pull request settings")}function h(e){return l.default.request("/ws/proxy",{method:"post",data:{service:"vcs",method:"get",path:`/v1/pull-requests/${e}/diff?navigation=true`}}).then((({body:e})=>Promise.resolve(e))).catch((({error:e})=>Promise.reject(e)))}function v(e,t){if(e&&t)return l.default.request(`/collection/diff/${e}?source=${t}&navigation=true`,{method:"get"}).then((({body:e})=>Promise.resolve(e))).catch((({error:e})=>Promise.reject(e)))}function y(e){const t=d.launchDarkly.getFlag(m.ENABLE_DIFF_MERGE_V2_FLAG.key,m.ENABLE_DIFF_MERGE_V2_FLAG.defaultValue);return l.default.request("/ws/proxy",{method:"post",data:{service:"vcs",method:"get",path:`/v1/pull-requests/${e}/merge-strategies?diffVersion=${t?"2.0.0":"1.0.0"}`}}).then((({body:e})=>Promise.resolve(e))).catch((({error:e})=>Promise.reject(e)))}function q(e){return Object(c.resolveStoreInstance)(a.default).isLoggedIn||pm.toasts.error("Please sign-in to manage pull requests.",{noIcon:!0,title:"Unable to create pull request"}),l.default.request("/ws/proxy",{method:"post",data:{service:"vcs",method:"post",path:"/v1/pull-requests",body:e}}).then((({body:e})=>Promise.resolve(e))).catch((({error:e})=>Promise.reject(e)))}function b(e,t){return Object(c.resolveStoreInstance)(a.default).isLoggedIn||pm.toasts.error("Please sign-in to manage pull requests.",{noIcon:!0,title:"Unable to update pull request"}),l.default.request("/ws/proxy",{method:"post",data:{service:"vcs",method:"put",path:`/v1/pull-requests/${e}`,body:t}}).then((({body:e})=>Promise.resolve(e))).catch((({error:e})=>Promise.reject(e)))}function E(e,t){Object(c.resolveStoreInstance)(a.default).isLoggedIn||pm.toasts.error("Please sign-in to manage pull requests.",{noIcon:!0,title:"Unable to merge pull request"});const r=d.launchDarkly.getFlag(m.ENABLE_DIFF_MERGE_V2_FLAG.key,m.ENABLE_DIFF_MERGE_V2_FLAG.defaultValue),o=t?{mergeStrategy:t}:{};return l.default.request("/ws/proxy",{method:"post",data:{service:"vcs",method:"put",path:`/v1/pull-requests/${e}/merge?diffVersion=${r?"2.0.0":"1.0.0"}`,body:o}}).then((({body:e})=>Promise.resolve(e))).catch((({error:e})=>Promise.reject(e)))}function P(e,t,r){return Object(c.resolveStoreInstance)(a.default).isLoggedIn||pm.toasts.error("Please sign-in to manage pull requests.",{noIcon:!0,title:"Unable to decline pull request"}),l.default.request("/ws/proxy",{method:"post",data:{service:"vcs",method:"put",path:`/v1/pull-requests/${e}/decline?diffVersion=${t}`,body:{comment:r}}}).then((({body:e})=>Promise.resolve(e))).catch((({error:e})=>Promise.reject(e)))}function j(e){return Object(c.resolveStoreInstance)(a.default).isLoggedIn||pm.toasts.error("Please sign-in to manage pull requests.",{noIcon:!0,title:"Unable to approve pull request"}),l.default.request("/ws/proxy",{method:"post",data:{service:"vcs",method:"put",path:`/v1/pull-requests/${e}/approve`,body:{}}}).then((({body:e})=>Promise.resolve(e))).catch((({error:e})=>Promise.reject(e)))}function I(e){return Object(c.resolveStoreInstance)(a.default).isLoggedIn||pm.toasts.error("Please sign-in to manage pull requests.",{noIcon:!0,title:"Unable to unapprove pull request"}),l.default.request("/ws/proxy",{method:"post",data:{service:"vcs",method:"put",path:`/v1/pull-requests/${e}/unapprove`,body:{}}}).then((({body:e})=>Promise.resolve(e))).catch((({error:e})=>Promise.reject(e)))}function w(e){return l.default.request(`/collection/roles/${e}`,{method:"get"}).then((({body:e})=>Promise.resolve(e))).catch((({error:e})=>Promise.reject(e)))}function _(e,t,r){return l.default.request("/ws/proxy",{method:"post",data:{service:"acs",method:"get",path:`/api/v1/entities?filter.objectType=${e}&filter.objectId=${t}&filter.permission=${r}&filter.entityTypes=user,group,team`}}).then((({body:e})=>e)).catch((({error:e})=>Promise.reject(e)))}function S(e){let t={};return(e||[]).forEach((e=>{t[e]={entityType:"group",entityId:"anybody",permission:"VIEW_COLLECTION",objectType:"collection",objectId:e}})),l.default.request("/ws/proxy",{method:"post",data:{service:"acs",method:"post",path:"/api/permissions/check",body:{checks:t}}}).then((({body:e})=>Promise.resolve(e))).catch((e=>Promise.resolve(e)))}function R(e,t){return e&&t||pm.toasts.error("Entity and Entity Id are required parameters",{noIcon:!0,title:"Invalid params"}),l.default.request("/ws/proxy",{method:"post",data:{service:"vcs",method:"get",path:`/v1/reviewer-suggestions?entity=${e}&entityId=${t}`}}).then((({body:e})=>Promise.resolve(e))).catch((e=>Promise.resolve(e)))}async function x(e,t,r){if("collection"===e)return async function(e,t){return t?l.default.request("/ws/proxy",{method:"post",data:{service:"vcs",method:"post",body:{settings:e},path:`/v1/pull-request-settings?entity=collection&entityId=${t}&mergers=true&populateUsers=true`}}).then((({body:e})=>Promise.resolve(e))).catch((({error:e})=>Promise.reject(e))):(pm.logger.error("PullRequestService~updatePullRequestSettings: entityId is a mandatory parameter"),Promise.reject(new Error("Something went wrong while updating pull request settings.")))}(r,t)}async function T(e,t){if("collection"===e){let{settings:e}=await async function(e){if(e)return l.default.request("/ws/proxy",{method:"post",data:{service:"vcs",method:"get",body:{},path:`/v1/pull-request-settings?entity=collection&entityId=${e}&mergers=true&populateUsers=true`}}).then((({body:e})=>Promise.resolve(e))).catch((({error:e})=>Promise.reject(e)));pm.logger.error("PullRequestService~fetchPullRequestSettings: No object id specified to fetch pull request settings")}(t);return{settings:e}}}function L({model:e,modelId:t,userId:r}){const o=s.a.get(u.default,`${e}.permissions.viewMergeSettings`);let n;return o&&(n=o({modelId:t,userId:r})),l.default.request("/ws/proxy",{method:"post",data:{service:"acs",method:"post",path:"/api/permissions/check",body:{checks:{prMergeSettingsView:n}}}}).then((({body:e})=>{const{results:t}=e;return s.a.get(t,"prMergeSettingsView.allowed",!1)}))}function k({prId:e,userId:t,destinationId:r}){return l.default.request("/ws/proxy",{method:"post",data:{service:"vcs",method:"post",path:"/v1/permissions/check?checkModelOrParent=true",body:{checks:{addComment:{entityType:"user",entityId:t,permission:"ADD_COMMENT_ON_PULL_REQUEST",objectType:"pullRequest",objectId:e},resolveComment:{entityType:"user",entityId:t,permission:"RESOLVE_COMMENT_ON_PULL_REQUEST",objectType:"pullRequest",objectId:e},deleteComment:{entityType:"user",entityId:t,permission:"DELETE_COMMENT_ON_PULL_REQUEST",objectType:"pullRequest",objectId:e}}}}}).then((({body:e})=>{const{results:t}=e;return{addComment:s.a.get(t,"addComment.allowed"),resolveComment:s.a.get(t,"resolveComment.allowed"),deleteComment:s.a.get(t,"deleteComment.allowed")}})).catch((e=>({addComment:!1,resolveComment:!1,deleteComment:!1})))}}}]);